﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Memcached.ClientLibrary;

namespace MemcachedTest
{
    class Program
    {
        static void Main(string[] args)
        {
            SockIOPool pool = SockIOPool.GetInstance();
            string[] servers = { "127.0.0.1:11211" };
            pool.SetServers(servers);
            pool.MinConnections = 3;
            pool.MaxConnections = 5;
            pool.InitConnections = 3;
            pool.SocketConnectTimeout = 5000;
            pool.Initialize();

            MemcachedClient client = new MemcachedClient();


            client.EnableCompression = false;
            Console.WriteLine("-----------------------Memcached Set 设置值--------------------------");
            client.Set("key1", "value1");
            Console.WriteLine(client.Get("key1"));
            Console.WriteLine("-----------------------Memcached Add 设置值--------------------------");
            client.Add("key2", "value2");
            Console.WriteLine(client.Get("key2"));
            client.Set("key2", "value1 value2");
            Console.WriteLine(client.Get("key2"));
            //Console.WriteLine("-----------------------Memcached Replace 设置值--------------------------");
            //client.Replace("key2", "value3");
            //Console.WriteLine(client.Get("key2"));

            //Console.WriteLine("-----------------------Memcached 键值是否存在--------------------------");
            //if (client.KeyExists("key2"))
            //{
            //    Console.WriteLine("键key2 存在");
            //}
            //if (client.KeyExists("hechen") == false)
            //{
            //    Console.WriteLine("键hechen 不存在");
            //}

            //Console.WriteLine("-----------------------Memcached 删除数据--------------------------");
            //client.Add("key4", "value4");
            //Console.WriteLine("key4==>" + client.Get("key4"));
            //client.Delete("key4");
            //if (!client.KeyExists("key4"))
            //{
            //    Console.WriteLine("key4 已将删除");
            //}

            //Console.WriteLine("-----------------------Memcached 数据过期--------------------------");
            //client.Add("key5", "value5", DateTime.Now.AddMilliseconds(5000));
            //Console.WriteLine(client.Get("key5"));
            //System.Threading.Thread.Sleep(6000);
            //Console.WriteLine("过期: " + client.Get("key5"));

            //ICache cache = Memcache.Instance();
            //Console.WriteLine(cache.ContainKey("hechen"));
            //Student student = new Student() { ID=1, Name="hechen"};
            //Console.WriteLine(cache.Add<Student>("hechen",student));
            //Console.WriteLine(cache.ContainKey("hechen"));
            //Student stu = cache.Get<Student>("hechen");
            //Console.WriteLine(stu.ID+":"+stu.Name);
            //cache.Add("qa","ddddddddd");
            //cache.Remove();
            //Student stu = cache.Get<Student>("hechen");
            //if (stu != null)
            //{
             //   Console.WriteLine(stu.ID + ":" + stu.Name);
           // }
           // Console.WriteLine(cache.Get("qa"));
        }
    }
}
