﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Collections;

namespace MemcachedTest
{
    public interface ICache
    {
        bool ContainKey(string argKey);

        bool Add(string argKey,object argValue);

        bool Add(string argKey, object argValue, DateTime argDateExpiration);

        bool Add<T>(string argKey, T entity) where T : class;

        bool Add<T>(string argKey, T entity, DateTime argDateExpiration) where T : class;

        bool Set(string argKey, object argValue);

        bool Set(string argKey, object argValue, DateTime argDateExpiration);

        bool Set<T>(string argKey, T entity) where T : class;

        bool Set<T>(string argKey, T entity, DateTime argDateExpiration) where T : class;

        bool Replace(string argKey,object argValue);

        bool Replace(string argKey,object argValue,DateTime argDateExpiration);

        bool Replace<T>(string argKey, T entity) where T : class;

        bool Replace<T>(string argKey, T entity, DateTime argDateExpiration) where T : class;

        object Get(string argKey);

        T Get<T>(string argKey);

        bool Remove(string argKey);

        bool Remove(string argKey, DateTime argDateExpiration);

        bool Remove();

        bool Remove(ArrayList servers);

    }
}
